﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data.SQLite;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace YGO_DeckAnalyzer
{
    public partial class YGODeckAnalyzer : Form
    {
        public YGODeckAnalyzer()
        {
            this.InitializeComponent();
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            btnStart.Enabled = false;
            if (!checkNoFile.Checked)
            {
                if (this.sfdSave.ShowDialog() != DialogResult.OK)
                {
                    return;
                }
                File.Delete(this.sfdSave.FileName);
            }
            bwWorker.RunWorkerAsync();
        }

        private string SpecialProcess_SeriesJudge(long card)
        {
            switch (card)
            {
                case 21362970:
                case 67757079:
                case 94878265:
                    return "00毛扎";
                case 32465539:
                case 94344242:
                case 68950538:
                case 58600555:
                case 12615446:
                case 85004150:
                case 83048208:
                    return "电子光虫";
                case 64631466:
                case 94259633:
                case 15173384:
                case 41426869:
                    return "0110"; //纳祭
                case 22339232:
                case 32274490:
                case 36021814:
                case 37675138:
                case 40991587:
                case 57473560:
                case 90243945:
                    return "00白骨";
                case 26400609:
                case 27415516:
                case 53797637:
                case 53804307:
                case 89185742:
                case 89399912:
                case 90411554:
                case 91020571:
                case 27770341:
                case 45725480:
                    return "00征龙";
                case 46947713:
                case 88093706:
                case 71278040:
                case 18789533:
                    return "0101"; //各类码语者
                case 5560911:
                case 28985331:
                case 7409792:
                case 9411399:
                case 3431737:
                case 9742784:
                case 25472513:
                case 67723438:
                case 65536818:
                case 53325667:
                case 94973028:
                case 74644400:
                case 72291078:
                case 75944053:
                    return "00均卡";
                case 5697558:
                    return "00ED"; //地中
                case 86120751:
                case 97973692:
                case 74063034:
                case 47679935:
                case 458748:
                case 47457347:
                    return "0召唤师";
                case 71564252:
                case 15397015:
                case 71197066:
                case 40605147:
                case 41420027:
                case 84749824:
                case 36975314:
                case 5851097:
                case 63845230:
                case 36584821:
                case 30241314:
                case 35059553:
                case 81674782:
                    return "BEAT";
                case 41373230:
                case 1984618:
                case 68468459:
                    return "0145"; //教导
                case 39185163:
                case 66570171:
                case 4064256:
                case 92964816:
                    return "不死世界";
                case 11110587:
                    return "00割草";
                case 11827244:
                    return "003B"; //圆融魔术-真红眼
                case 31443476:
                    return "010F"; //速攻旋转 - 弹丸
                case 53936268:
                    return "0103"; //个人欺骗攻击 - 骚灵
                case 30603688:
                case 7084129:
                case 1784686:
                case 73616671:
                case 47222536:
                case 7922915:
                case 48680970:
                case 96471335:
                case 85551711:
                case 75380687:
                case 41721210:
                    return "10A2"; //黑魔导
                case 15180041:
                case 19502505:
                case 41175645:
                case 25290459:
                case 90500169:
                    return "0041"; //LV - 无LV的卡
                case 18940556:
                case 41782653:
                case 38572779:
                case 44335251:
                case 36042004:
                case 38179121:
                    return "00恐龙";
                case 79814787:
                case 71039903:
                case 72855441:
                case 34627841:
                case 45644898:
                case 8240199:
                case 36734924:
                case 88241506:
                case 2783661:
                case 29432790:
                case 50371210:
                case 56920308:
                case 93437091:
                case 17655904:
                case 57043986:
                    return "00DD"; //青眼
                case 11012154:
                case 6990577:
                case 43411769:
                case 79905468:
                case 84899094:
                case 59537380:
                case 13143275:
                case 86148577:
                case 87571563:
                case 50186558:
                case 47393199:
                case 11908584:
                    return "0守护龙";
                case 37694547:
                    return "0007"; //齿车街 - 古代机械
                case 10000040:
                case 10000000:
                case 10000010:
                case 10000020:
                    return "0三幻神";
                case 87116928:
                case 79229522:
                    return "1093"; //电子龙 - 嵌合
                case 67831115:
                case 27705190:
                case 89320376:
                    return "0104"; //机怪虫 - 几张机怪虫相关星遗物
                case 36468556:
                case 91623717:
                case 18252559:
                case 24068492:
                case 27053506:
                    return "BURN";
                case 2819435:
                    return "00FA"; //幻煌
                case 30012506:
                case 77411244:
                case 3405259:
                case 1561110:
                    return "0ABC";
                case 51126152:
                case 52481437:
                case 13647631:
                case 88875132:
                case 24919805:
                case 76136345:
                case 25274141:
                case 26096328:
                    return "00列车";
                case 92379223:
                case 31434645:
                    return "0黄金国";
                case 53855409:
                case 96363153:
                case 37675907:
                case 50091196:
                case 20932152:
                case 80457744:
                    return "00废二";
                case 89397517:
                    return "00A0"; //传说的骑士->传说之龙
                case 26293219:
                case 99899504:
                case 63804806:
                    return "0骷髅头";
                case 90764875:
                case 64379261:
                case 37984162:
                case 84401683:
                case 37168514:
                    return "00蛇头";
                case 93130021:
                case 10992251:
                case 10642488:
                case 14089428:
                case 5494820:
                case 14291024:
                    return "0胜利蛇";
                case 62340868:
                case 25955164:
                case 98434877:
                case 25833572:
                    return "属性魔神";
                case 36562627:
                case 49511705:
                case 96012004:
                case 70050374:
                case 28112535:
                case 76728962:
                case 3549275:
                case 39454112:
                case 93078761:
                    return "00赌博";
                case 81171949:
                    return "头奖壶7";
                case 6853254:
                    return "00DD0巨神龙";
                case 6075801:
                case 33282498:
                case 33460840:
                case 60681103:
                case 69868555:
                case 87835759:
                    return "0巨神龙";
                case 4148264:
                case 58012707:
                    return "0G战队";
                case 899287:
                case 14512825:
                case 41916534:
                case 45072394:
                case 46294982:
                case 72283691:
                case 73405179:
                case 78527720:
                    return "00金宫";
                case 59160188:
                case 50383626:
                case 29424328:
                case 23898021:
                case 25643346:
                case 86377375:
                    return "黯黑世界";
                case 24096499:
                case 36318200:
                case 77797992:
                case 97317530:
                    return "森之圣兽";
                case 28118128:
                case 92729410:
                case 39972129:
                    return "00子狸";
                case 80208158:
                case 15574615:
                case 16796157:
                case 43791861:
                case 79185500:
                    return "00罗宾";
                case 8198712:
                case 32828635:
                case 69217334:
                case 95612049:
                case 81306186:
                case 59913418:
                case 72426662:
                case 86124104:
                    return "世界末日";
                case 95308449:
                    return "0倒计时";
                case 94212438:
                case 67287533:
                case 31893528:
                case 30170981:
                case 94772232:
                case 40771118:
                case 14386013:
                case 16625614:
                    return "0通灵盘";
                case 93151201:
                case 84530620:
                case 15510988:
                case 70797118:
                case 57019473:
                case 21524779:
                case 27217742:
                    return "雷电家族";
                case 75917088:
                case 2316186:
                case 72709014:
                case 74270067:
                case 58015506:
                    return "王女试炼";
                case 440556:
                case 80727036:
                case 7500772:
                case 50449881:
                case 50532786:
                case 70655556:
                case 11954712:
                case 23536866:
                case 51227866:
                case 17201174:
                case 67111213:
                case 43138260:
                case 70101178:
                case 71923655:
                case 20838380:
                case 2584136:
                case 32393580:
                case 84224627:
                case 14306092:
                case 5014629:
                case 28593363:
                case 49221191:
                case 37798171:
                case 44223284:
                case 21954587:
                case 34290067:
                case 93830681:
                case 70156946:
                case 69155991:
                case 47840168:
                case 20358953:
                case 71015787:
                case 13429800:
                case 51254277:
                case 11845050:
                case 10532969:
                case 25484449:
                case 64319467:
                case 17643265:
                case 7150545:
                case 63193879:
                case 37792478:
                case 87047161:
                case 23672629:
                case 59479050:
                case 31320433:
                case 37279508:
                case 65676461:
                    return "00鲨鱼";
                case 77506119:
                case 49389523:
                case 63595262:
                case 64047146:
                case 13995824:
                case 10321588:
                case 20351153:
                case 58807980:
                case 58685438:
                case 22318971:
                    return "0独角兽";
                case 58901502:
                case 63364266:
                case 59255742:
                case 84305651:
                case 98637386:
                case 7391448:
                    return "00御用";
                case 3070049:
                case 67675300:
                case 73659078:
                case 15893860:
                case 32750510:
                case 24661486:
                    return "冰指示物";
                case 61802346:
                case 50920465:
                case 43694481:
                case 96565487:
                case 28348537:
                case 51706604:
                    return "00雪暴";
                case 95929069:
                case 68535320:
                case 16223761:
                    return "冰火手";
                case 49003308:
                case 9053187:
                case 43793530:
                case 39674352:
                case 53776525:
                    return "魔蜥义豪";
                case 39389320:
                case 42233477:
                case 78621186:
                case 40453765:
                case 20394040:
                    return "0野蛮人";
                case 20765952:
                case 22610082:
                case 29549364:
                case 57882509:
                case 56948373:
                case 82432018:
                case 94377247:
                case 49064413:
                case 48948935:
                    return "假面魔兽";
                case 8508055:
                case 55550921:
                case 82452993:
                case 3810071:
                case 49814180:
                case 96458440:
                case 97570038:
                    return "00格斗";
                case 84814897:
                case 91597389:
                case 87798440:
                case 7369217:
                case 87564935:
                case 8964854:
                case 63676256:
                case 59364406:
                case 47415292:
                case 31768112:
                case 12965761:
                case 69456283:
                case 11678191:
                case 72083436:
                case 11743119:
                case 99249638:
                case 26931058:
                case 39778366:
                case 19086954:
                case 46181000:
                case 85359414:
                case 47693640:
                case 57062206:
                    return "00同盟";
                case 96029574:
                case 95750695:
                case 91798373:
                case 81601517:
                case 19041767:
                case 26120084:
                case 16984449:
                    return "00二重";
                case 80476891:
                case 55100740:
                case 44088292:
                case 38026562:
                case 18993198:
                    return "0化合兽";
                case 99173029:
                case 92394653:
                case 92200612:
                case 90365482:
                case 82841979:
                case 74115234:
                case 73055622:
                case 66815913:
                case 52900000:
                case 48716139:
                case 43543777:
                case 43378076:
                case 39817919:
                case 37406863:
                case 32181268:
                case 30461781:
                case 25415052:
                case 24701235:
                case 16889337:
                case 9553721:
                case 6544078:
                case 1200843:
                case 276357:
                    return "00灵魂";
                case 42352091:
                case 79747096:
                case 4019153:
                case 15232745:
                case 42230449:
                case 78625448:
                case 77402960:
                case 41418852:
                    return "源数之门";
            }
            return null;
        }

        private void AddCustomSeries(ref Dictionary<string, string> series)
        {
            series.Add("00恐龙", "恐龙");
            series.Add("0ABC", "ABC");
            series.Add("BEAT", "METABEAT");
            series.Add("不死世界", "不死世界");
            series.Add("00割草", "割草");
            series.Add("00均卡", "均卡(LINK/同调)");
            series.Add("0守护龙", "守护龙");
            series.Add("0三幻神", "三幻神");
            series.Add("BURN", "烧血");
            series.Add("00列车", "列车");
            series.Add("0召唤师", "召唤师");
            series.Add("00废二", "废二");
            series.Add("00幻魔", "幻魔");
            series.Add("00征龙", "征龙");
            series.Add("00白骨", "白骨");
            series.Add("电子光虫", "电子光虫");
            series.Add("00毛扎", "毛扎");
            series.Add("0骷髅头", "燃烧骷髅头");
            series.Add("00蛇头", "蛇头");
            series.Add("0胜利蛇", "胜利蛇");
            series.Add("属性魔神", "门之守护神");
            series.Add("00赌博", "骰子与硬币");
            series.Add("头奖壶7", "头奖壶");
            series.Add("0巨神龙", "巨神龙");
            series.Add("0G战队", "G战队");
            series.Add("00金宫", "急流山的金宫");
            series.Add("黯黑世界", "黯黑世界");
            series.Add("森之圣兽", "森之圣兽");
            series.Add("00子狸", "子狸");
            series.Add("00罗宾", "星斗罗宾");
            series.Add("世界末日", "世界末日");
            series.Add("0倒计时", "倒计时");
            series.Add("0通灵盘", "通灵盘");
            series.Add("雷电家族", "雷电家族");
            series.Add("王女试炼", "王女试炼");
            series.Add("00鲨鱼", "鲨");
            series.Add("0独角兽", "独角兽");
            series.Add("00御用", "御用");
            series.Add("冰指示物", "冰指示物");
            series.Add("00雪暴", "雪暴");
            series.Add("0冰火手", "冰火手");
            series.Add("魔蜥义豪", "魔蜥义豪");
            series.Add("0野蛮人", "野蛮人");
            series.Add("假面魔兽", "假面魔兽");
            series.Add("00格斗", "格斗武僧");
            series.Add("00同盟", "各种同盟均");
            series.Add("00二重", "各种二重均");
            series.Add("00灵魂", "各种灵魂均");
            series.Add("0化合兽", "化合兽");
            series.Add("源数之门", "源数之门");
        }

        private Dictionary<string, string> SpecialProcess(Dictionary<string, string> series)
        {
            this.AddCustomSeries(ref series);

            if (series.Keys.Contains("004B"))
            {
                series["004B"] = "极星";
            }
            if (series.Keys.Contains("010E")) //进化药
            {
                series["010E"] = "恐龙";
            }
            if (series.Keys.Contains("00B9"))
            {
                series["00B9"] = "火山";
            }
            if (series.Keys.Contains("0125"))
            {
                series["0125"] = null; //笑容
            }
            if (series.Keys.Contains("00B6"))
            {
                series["00B6"] = null; //外神
            }
            if (series.Keys.Contains("00B7"))
            {
                series["00B7"] = null; //古神
            }
            if (series.Keys.Contains("00B8"))
            {
                series["00B8"] = null; //旧神
            }
            if (series.Keys.Contains("1017"))
            {
                series["1017"] = null; //同调士
            }
            if (series.Keys.Contains("00C2"))
            {
                series["00C2"] = null; //动力工具
            }
            if (series.Keys.Contains("0123"))
            {
                series["0123"] = "蔷薇龙"; //蔷薇
            }
            if (series.Keys.Contains("007E"))
            {
                series["007E"] = "霍普";
            }
            if (series.Keys.Contains("00A0"))
            {
                series["00A0"] = "传说之龙"; //传说的骑士
            }
            if (series.Keys.Contains("2017"))
            {
                series["2017"] = null; //同调龙
            }
            if (series.Keys.Contains("0061"))
            {
                series["0061"] = "忍者";
            }
            if (series.Keys.Contains("001E"))
            {
                series["001E"] = "HERO";
            }
            if (series.Keys.Contains("001F"))
            {
                series["001F"] = "HERO";
            }
            if (series.Keys.Contains("0007"))
            {
                series["0007"] = "古代机械";
            }
            if (series.Keys.Contains("00A3"))
            {
                series["00A3"] = null; //星尘
            }
            if (series.Keys.Contains("011D"))
            {
                series["011D"] = null; //禁忌的
            }
            if (series.Keys.Contains("0073"))
            {
                series["0073"] = null; //超量
            }
            if (series.Keys.Contains("0110"))
            {
                series["0110"] = "纳祭";
            }
            if (series.Keys.Contains("0066"))
            {
                series["0066"] = "废二";
            }
            if (series.Keys.Contains("0119"))
            {
                series["0119"] = "炎兽";
            }
            if (series.Keys.Contains("0118"))
            {
                series["0118"] = null;
            }
            if (series.Keys.Contains("0101"))
            {
                series["0101"] = "电子界";
            }
            if (series.Keys.Contains("0065"))
            {
                series["0065"] = "入魔";
            }
            if (series.Keys.Contains("00DB"))
            {
                series["00DB"] = "幻影骑士团";
            }
            if (series.Keys.Contains("00C5"))
            {
                series["00C5"] = "狱火机";
            }
            if (series.Keys.Contains("004C"))
            {
                series["004C"] = null; //落穴
            }
            if (series.Keys.Contains("0040"))
            {
                series["0040"] = "艾克佐迪亚";
            }
            if (series.Keys.Contains("00AB"))
            {
                series["00AB"] = "文具人";
            }
            if (series.Keys.Contains("010D"))
            {
                series["010D"] = "魔导兽";
            }
            if (series.Keys.Contains("0099"))
            {
                series["0099"] = "魔术师";
            }
            if (series.Keys.Contains("1002"))
            {
                series["1002"] = "次世代";
            }
            if (series.Keys.Contains("3008"))
            {
                series["3008"] = "HERO";
            }
            if (series.Keys.Contains("5008"))
            {
                series["5008"] = "HERO";
            }
            if (series.Keys.Contains("6008"))
            {
                series["6008"] = "HERO";
            }
            if (series.Keys.Contains("A008"))
            {
                series["A008"] = "HERO";
            }
            if (series.Keys.Contains("C008"))
            {
                series["C008"] = "HERO";
            }
            if (series.Keys.Contains("0071"))
            {
                series["0071"] = "甜点";
            }
            if (series.Keys.Contains("0009"))
            {
                series["0009"] = "HERO";
            }
            if (series.Keys.Contains("0008"))
            {
                series["0008"] = "HERO";
            }
            if (series.Keys.Contains("100A"))
            {
                series["100A"] = "入魔";
            }
            if (series.Keys.Contains("3013"))
            {
                series["3013"] = "机皇";
            }
            if (series.Keys.Contains("6013"))
            {
                series["6013"] = "机皇";
            }
            if (series.Keys.Contains("0020"))
            {
                series["0020"] = "六武众";
            }
            if (series.Keys.Contains("1033"))
            {
                series["1033"] = "黑羽";
            }
            if (series.Keys.Contains("0034"))
            {
                series["0034"] = "宝玉兽";
            }
            if (series.Keys.Contains("2034"))
            {
                series["2034"] = "宝玉兽";
            }
            if (series.Keys.Contains("103D"))
            {
                series["103D"] = "六武众";
            }
            if (series.Keys.Contains("3042"))
            {
                series["3042"] = "极星";
            }
            if (series.Keys.Contains("5042"))
            {
                series["5042"] = "极星";
            }
            if (series.Keys.Contains("6042"))
            {
                series["6042"] = "极星";
            }
            if (series.Keys.Contains("A042"))
            {
                series["A042"] = "极星";
            }
            if (series.Keys.Contains("0047"))
            {
                series["0047"] = "宝石骑士";
            }
            if (series.Keys.Contains("010C"))
            {
                series["010C"] = "机界";
            }
            if (series.Keys.Contains("0112"))
            {
                series["0112"] = null; //幻崩
            }
            if (series.Keys.Contains("0048"))
            {
                series["0048"] = null; //No
            }
            if (series.Keys.Contains("1048"))
            {
                series["1048"] = null; //CNo
            }
            if (series.Keys.Contains("1073"))
            {
                series["1073"] = null; //CX
            }
            if (series.Keys.Contains("2073"))
            {
                series["2073"] = null; //超量龙
            }
            if (series.Keys.Contains("0046"))
            {
                series["0046"] = null; //融合
            }
            if (series.Keys.Contains("0096"))
            {
                series["0096"] = null; //电子鱼人
            }
            if (series.Keys.Contains("0095"))
            {
                series["0095"] = null; //升阶魔法
            }
            if (series.Keys.Contains("304E"))
            {
                series["304E"] = "进化龙";
            }
            if (series.Keys.Contains("504E"))
            {
                series["504E"] = "进化龙";
            }
            if (series.Keys.Contains("006F"))
            {
                series["006F"] = "英豪挑战者";
            }
            if (series.Keys.Contains("0092"))
            {
                series["0092"] = "纹章兽";
            }
            if (series.Keys.Contains("1072"))
            {
                series["1072"] = "齿轮齿轮";
            }
            if (series.Keys.Contains("10F8"))
            {
                series["10F8"] = "魔术师";
            }
            if (series.Keys.Contains("20F8"))
            {
                series["20F8"] = null;
            }
            if (series.Keys.Contains("010D"))
            {
                series["010D"] = "魔导兽";
            }
            if (series.Keys.Contains("107A"))
            {
                series["107A"] = "圣骑士";
            }
            if (series.Keys.Contains("207A"))
            {
                series["207A"] = "圣骑士";
            }
            if (series.Keys.Contains("007B"))
            {
                series["007B"] = "银河眼";
            }
            if (series.Keys.Contains("0055"))
            {
                series["0055"] = "银河眼";
            }
            if (series.Keys.Contains("307B"))
            {
                series["307B"] = "银河眼";
            }
            if (series.Keys.Contains("009F"))
            {
                series["009F"] = "魔术师";
            }
            if (series.Keys.Contains("007D"))
            {
                series["007D"] = "阳炎兽";
            }
            if (series.Keys.Contains("107F"))
            {
                series["107F"] = "霍普";
            }
            if (series.Keys.Contains("207F"))
            {
                series["207F"] = "霍普";
            }
            if (series.Keys.Contains("1081"))
            {
                series["1081"] = "炎王";
            }
            if (series.Keys.Contains("0075"))
            {
                series["0075"] = null; //深渊
            }
            if (series.Keys.Contains("0093"))
            {
                series["0093"] = "电子龙";
            }
            if (series.Keys.Contains("0094"))
            {
                series["0094"] = "电子龙";
            }
            if (series.Keys.Contains("109A"))
            {
                series["109A"] = "超重武者";
            }
            if (series.Keys.Contains("109B"))
            {
                series["109B"] = "幻奏";
            }
            if (series.Keys.Contains("109C"))
            {
                series["109C"] = "星守";
            }
            if (series.Keys.Contains("10A2"))
            {
                series["10A2"] = "黑魔导";
            }
            if (series.Keys.Contains("20A2"))
            {
                series["20A2"] = "黑魔导";
            }
            if (series.Keys.Contains("30A2"))
            {
                series["30A2"] = "黑魔导";
            }
            if (series.Keys.Contains("10A4"))
            {
                series["10A4"] = "栗子球"; //羽翼栗子球
            }
            if (series.Keys.Contains("00A5"))
            {
                series["00A5"] = "HERO";
            }
            if (series.Keys.Contains("10AA"))
            {
                series["10AA"] = "机壳";
            }
            if (series.Keys.Contains("00AF"))
            {
                series["00AF"] = "DDD";
            }
            if (series.Keys.Contains("00D7"))
            {
                series["00D7"] = "破坏剑";
            }
            if (series.Keys.Contains("00C6"))
            {
                series["00C6"] = "魔术师";
            }
            if (series.Keys.Contains("00C7"))
            {
                series["00C7"] = "魔术师";
            }
            if (series.Keys.Contains("00CE"))
            {
                series["00CE"] = "水伶女";
            }
            if (series.Keys.Contains("00A9"))
            {
                series["00A9"] = "魔玩具";
            }
            if (series.Keys.Contains("00C3"))
            {
                series["00C3"] = "魔玩具";
            }
            if (series.Keys.Contains("10B5"))
            {
                series["10B5"] = "灵兽";
            }
            if (series.Keys.Contains("20B5"))
            {
                series["20B5"] = "灵兽";
            }
            if (series.Keys.Contains("40B5"))
            {
                series["40B5"] = "灵兽";
            }
            if (series.Keys.Contains("10C1"))
            {
                series["10C1"] = "PSY骨架";
            }
            if (series.Keys.Contains("10D9"))
            {
                series["10D9"] = "不知火";
            }
            if (series.Keys.Contains("00EA"))
            {
                series["00EA"] = "水晶机巧";
            }
            if (series.Keys.Contains("10DC"))
            {
                series["10DC"] = "超级量子";
            }
            if (series.Keys.Contains("20DC"))
            {
                series["20DC"] = "超级量子";
            }
            if (series.Keys.Contains("20EC"))
            {
                series["20EC"] = "魔界剧团";
            }
            if (series.Keys.Contains("10ED"))
            {
                series["10ED"] = "地中族";
            }
            if (series.Keys.Contains("10EE"))
            {
                series["10EE"] = "秘旋谍";
            }
            if (series.Keys.Contains("20EE"))
            {
                series["20EE"] = "秘旋谍";
            }
            if (series.Keys.Contains("00F2"))
            {
                series["00F2"] = "魔术师";
            }
            if (series.Keys.Contains("10F2"))
            {
                series["10F2"] = "魔术师";
            }
            if (series.Keys.Contains("20F2"))
            {
                series["20F2"] = "魔术师";
            }
            if (series.Keys.Contains("00F3"))
            {
                series["00F3"] = "捕食植物";
            }
            if (series.Keys.Contains("00F4"))
            {
                series["00F4"] = "召唤师";
            }
            if (series.Keys.Contains("0102"))
            {
                series["0102"] = "枪管";
            }
            if (series.Keys.Contains("1115"))
            {
                series["1115"] = "闪刀";
            }
            if (series.Keys.Contains("00FD"))
            {
                series["00FD"] = "星遗物";
            }
            if (series.Keys.Contains("1130"))
            {
                series["1130"] = "破械";
            }
            if (series.Keys.Contains("013B"))
            {
                series["013B"] = null; //叛逆
            }
            if (series.Keys.Contains("013C"))
            {
                series["013C"] = null; //代码破坏者
            }
            if (series.Keys.Contains("0143"))
            {
                series["0143"] = "黄金国";
            }
            if (series.Keys.Contains("2142"))
            {
                series["2142"] = "黄金国";
            }
            if (series.Keys.Contains("1143"))
            {
                series["1143"] = "黄金国";
            }
            if (series.Keys.Contains("0148"))
            {
                series["0148"] = "圣骑士";
            }
            if (series.Keys.Contains("0054"))
            {
                series["0054"] = "拟声(我我我/怒怒怒等)";
            }
            if (series.Keys.Contains("0059"))
            {
                series["0059"] = "拟声(我我我/怒怒怒等)";
            }
            if (series.Keys.Contains("008F"))
            {
                series["008F"] = "拟声(我我我/怒怒怒等)";
            }
            if (series.Keys.Contains("013A"))
            {
                series["013A"] = "拟声(我我我/怒怒怒等)";
            }
            if (series.Keys.Contains("0082"))
            {
                series["0082"] = "拟声(我我我/怒怒怒等)"; //蔷薇
            }
            if (series.Keys.Contains("00C0"))
            {
                series["00C0"] = "灵使"; //蔷薇
            }
            if (series.Keys.Contains("0091"))
            {
                series["0091"] = "守墓"; //蔷薇
            }
            return series;
        }

        private void btnChooseStringsConf_Click(object sender, EventArgs e)
        {
            if (this.ofdStringsConf.ShowDialog() == DialogResult.OK)
            {
                this.txtStringsConf.Text = this.ofdStringsConf.FileName;
            }
        }
        bool init = true;


        private void Form1_Load(object sender, EventArgs e)
        {
            this.txtStringsConf.Text = Properties.Settings.Default.StringsConf;
            this.txtCardsCdb.Text = Properties.Settings.Default.CardsCdb;
            this.ofdCardsCdb.InitialDirectory = Properties.Settings.Default.CardsCdbDir;
            this.ofdStringsConf.InitialDirectory = Properties.Settings.Default.StringsConfDir;
            this.checkOutputDescription.Checked = Properties.Settings.Default.OutputDescription;
            this.checkAllowMixDeck.Checked = Properties.Settings.Default.AllowMixDeck;
            this.checkNoFile.Checked = Properties.Settings.Default.NoFile;
            this.checkMostOnly.Checked = Properties.Settings.Default.MostOnly;
            this.init = false;
        }

        private void txtStringsConf_TextChanged(object sender, EventArgs e)
        {
            this.SaveOptions();
        }

        private void SaveOptions()
        {
            if (!this.init)
            {
                Properties.Settings.Default.StringsConf = this.txtStringsConf.Text;
                Properties.Settings.Default.CardsCdb = this.txtCardsCdb.Text;
                Properties.Settings.Default.CardsCdbDir = this.ofdCardsCdb.InitialDirectory;
                Properties.Settings.Default.StringsConfDir = this.ofdStringsConf.InitialDirectory;
                Properties.Settings.Default.OutputDescription = this.checkOutputDescription.Checked;
                Properties.Settings.Default.AllowMixDeck = this.checkAllowMixDeck.Checked;
                Properties.Settings.Default.Save();
            }
        }

        private void txtCardsCdb_TextChanged(object sender, EventArgs e)
        {
            this.SaveOptions();
        }

        private void btnChooseCardsCdb_Click(object sender, EventArgs e)
        {
            if (this.ofdCardsCdb.ShowDialog() == DialogResult.OK)
            {
                this.txtCardsCdb.Text = this.ofdCardsCdb.FileName;
            }
        }

        private void listDecks_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent(DataFormats.FileDrop))
            {
                e.Effect = DragDropEffects.All;
            }
        }

        private void listDecks_DragDrop(object sender, DragEventArgs e)
        {
            string[] files = (string[])e.Data.GetData(DataFormats.FileDrop);
            foreach (string file in files)
            {
                if (Directory.Exists(file))
                {
                    this.listDecks.Items.AddRange(Directory.EnumerateFiles(file, "*.ydk", SearchOption.AllDirectories).ToArray());
                }
                else
                {
                    this.listDecks.Items.Add(file);
                }
            }
        }

        private void btnClear_Click(object sender, EventArgs e)
        {
            this.listDecks.Items.Clear();
        }

        private void checkAllowMixDeck_CheckedChanged(object sender, EventArgs e)
        {
            Properties.Settings.Default.AllowMixDeck = this.checkAllowMixDeck.Checked;
            this.SaveOptions();
        }

        private void checkOutputDescription_CheckedChanged(object sender, EventArgs e)
        {
            Properties.Settings.Default.OutputDescription = this.checkOutputDescription.Checked;
            this.SaveOptions();
        }

        private void CheckNoFile_CheckedChanged(object sender, EventArgs e)
        {
            Properties.Settings.Default.NoFile = checkNoFile.Checked;
            this.SaveOptions();
        }

        private void CheckMostOnly_CheckedChanged(object sender, EventArgs e)
        {
            Properties.Settings.Default.MostOnly = checkMostOnly.Checked;
            this.SaveOptions();
        }

        private void bwWorker_DoWork(object sender, DoWorkEventArgs e)
        {
            int failed = 0;
            FileStream fsout = null;
            StreamWriter sw = null;
            FileStream fs = null;
            StreamReader sr = null;
            SQLiteConnection sql = new SQLiteConnection($"Data Source={this.txtCardsCdb.Text};");
            SQLiteCommand cmd = new SQLiteCommand(sql);
            Dictionary<string, string> series = new Dictionary<string, string>();
            Dictionary<string, int> overAllDeckType = new Dictionary<string, int>();
            try
            {
                sql.Open();
                fs = File.OpenRead(this.txtStringsConf.Text);
                sr = new StreamReader(fs);
                for (string line = sr.ReadLine(); line != null; line = sr.ReadLine())
                {
                    line = line.Trim().ToUpper();
                    if (line.StartsWith("!SETNAME"))
                    {
                        string[] lineSplit = line.Split(' ');
                        series.Add(lineSplit[1].Substring(2).PadLeft(4, '0'), lineSplit[2].Split('\t')[0]);
                    }
                }
                sr.Close();
                fs.Close();
                series = this.SpecialProcess(series);
                if (!checkNoFile.Checked)
                {
                    fsout = File.OpenWrite(this.sfdSave.FileName);
                    sw = new StreamWriter(fsout, Encoding.UTF8);
                    if (this.checkOutputDescription.Checked)
                    {
                        sw.WriteLine("----------------------------------");
                        sw.WriteLine($"卡组分析（共{this.listDecks.Items.Count}个）");
                        sw.WriteLine("----------------------------------");
                    }
                }
                cmd.CommandText = $"SELECT id,setcode FROM datas";
                var rdr = cmd.ExecuteReader();

                Dictionary<long, string> cardSetCode = new Dictionary<long, string>();
                while (rdr.Read())
                {
                    long card = (long)rdr["id"];
                    long setcode = (long)rdr["setcode"];
                    string setcodeString = setcode.ToString("X");
                    int realLen = (4 - (setcodeString.Length % 4));
                    if (realLen == 4)
                    {
                        realLen = 0;
                    }
                    realLen += setcodeString.Length;
                    setcodeString = setcodeString.PadLeft(realLen, '0');
                    if (setcodeString != "0000")
                    {
                        cardSetCode.Add(card, setcodeString);
                    }
                    else
                    {
                        cardSetCode.Add(card, "");
                    }
                }
                rdr.Close();

                int completed = 0;
                foreach (object obj in this.listDecks.Items)
                {
                    try
                    {
                        fs = File.OpenRead(obj as string);
                        sr = new StreamReader(fs);
                        Dictionary<string, int> deckCardSeries = new Dictionary<string, int>();
                        bool atMain = true;
                        int main = 0;
                        for (string line = sr.ReadLine(); line != null; line = sr.ReadLine())
                        {
                            line = line.Trim();
                            long card = -1;
                            if (line.StartsWith("#extra"))
                            {
                                atMain = false;
                            }
                            if (long.TryParse(line, out card))
                            {
                                if (atMain)
                                {
                                    main++;
                                }
                                string setcodeString = cardSetCode[card];
                                string processing = this.SpecialProcess_SeriesJudge(card);
                                if (processing != null)
                                {
                                    setcodeString = processing;
                                }
                                while (setcodeString.Length > 0)
                                {
                                    processing = setcodeString.Substring(0, 4);
                                    setcodeString = setcodeString.Substring(4);
                                    if (deckCardSeries.Keys.Contains(processing))
                                    {
                                        deckCardSeries[processing]++;
                                    }
                                    else
                                    {
                                        deckCardSeries.Add(processing, 1);
                                    }
                                }
                            }
                        }
                        List<string> deckType = new List<string>();
                        int most = 0;
                        string mostType = "";
                        if (this.checkOutputDescription.Checked && !checkNoFile.Checked)
                        {
                            sw.WriteLine($"{obj as string}:");
                        }
                        Dictionary<string, int> deckCardSeriesFilter = new Dictionary<string, int>();
                        foreach (KeyValuePair<string, int> kvp in deckCardSeries)
                        {
                            string serie = "";
                            if (!series.ContainsKey(kvp.Key))
                            {
                                serie = $"未知(0x{kvp.Key})";
                            }
                            else
                            {
                                serie = series[kvp.Key];
                            }
                            if (serie != null)
                            {
                                if (deckCardSeriesFilter.ContainsKey(serie))
                                {
                                    deckCardSeriesFilter[serie] += kvp.Value;
                                }
                                else
                                {
                                    deckCardSeriesFilter.Add(serie, kvp.Value);
                                }
                            }
                        }
                        string postfix = "";
                        while (deckCardSeriesFilter.Count > 0)
                        {
                            most = 0;
                            mostType = "";
                            //foreach (KeyValuePair<string,int> kvp in deckCardSeries)
                            //{
                            //    if (kvp.Value > most)
                            //    {
                            //        most = kvp.Value;
                            //        mostTypeKey = kvp.Key;
                            //        if (!series.ContainsKey(mostTypeKey))
                            //        {
                            //            mostType = $"未知(0x{mostTypeKey})";
                            //        }
                            //        else
                            //        {
                            //            mostType = series[mostTypeKey];
                            //        }
                            //    }
                            //}
                            foreach (KeyValuePair<string, int> kvp in deckCardSeriesFilter)
                            {
                                if (kvp.Value > most)
                                {
                                    most = kvp.Value;
                                    mostType = kvp.Key;
                                }
                            }
                            if (most <= 6 && (!checkMostOnly.Checked || most <= 3))
                            {
                                if (deckCardSeriesFilter.Keys.Contains("割草"))
                                {
                                    deckType.Add("割草");
                                }
                                if (deckCardSeriesFilter.Keys.Contains("机巧蛇"))
                                {
                                    deckType.Add("机巧蛇");
                                }
                                break;
                            }
                            else
                            {
                                if (this.checkOutputDescription.Checked && !checkNoFile.Checked)
                                {
                                    sw.WriteLine($"{mostType}系列投入：{most}");
                                }
                                if (!deckType.Contains(mostType))
                                {
                                    deckType.Add(mostType);
                                }
                                deckCardSeriesFilter.Remove(mostType);
                            }
                        }
                        if (deckType.Count == 0)
                        {
                            deckType.Add("其他");
                        }
                        //deckType.Sort();
                        string realDeckType = "";
                        if (!checkMostOnly.Checked)
                        {
                            if (deckType.Contains("割草"))
                            {
                                realDeckType = "割草";
                                deckType.Remove("割草");
                            }
                            if (main > 55 && realDeckType != "割草")
                            {
                                realDeckType = $"{main}张";
                            }
                        }
                        if (deckType.Count > 1)
                        {
                            if (deckType.Contains("METABEAT"))
                            {
                                deckType.Remove("METABEAT");
                            }
                            if (deckType.Contains("均卡(LINK/同调)"))
                            {
                                deckType.Remove("均卡(LINK/同调)");
                            }
                            if (deckType.Contains("黑魔导") || deckType.Contains("召唤师"))
                            {
                                deckType.Remove("风魔女");
                            }
                            if (deckType.Contains("恩底弥翁"))
                            {
                                deckType.Remove("魔导兽");
                            }
                            if (deckType.Contains("甘多拉"))
                            {
                                deckType.Remove("守护龙");
                                deckType.Remove("圣像骑士");
                                deckType.Remove("龙骑兵团");
                            }
                        }
                        if (deckType.Count >= 3 && this.checkAllowMixDeck.Checked)
                        {
                            realDeckType = "多系列混合";
                        }
                        else
                        {
                            if (!checkMostOnly.Checked)
                            {
                                realDeckType += postfix;
                                foreach (string type in deckType)
                                {
                                    realDeckType += type;
                                }
                            }
                            else
                            {
                                realDeckType = deckType[0];
                            }
                        }
                        if (realDeckType.EndsWith("张其他"))
                        {
                            realDeckType = "其他";
                        }
                        //总览记录
                        if (!overAllDeckType.ContainsKey(realDeckType))
                        {
                            overAllDeckType.Add(realDeckType, 1);
                        }
                        else
                        {
                            overAllDeckType[realDeckType]++;
                        }
                    }
                    catch
                    {
                        failed++;
                    }
                    finally
                    {
                        sr.Close();
                        fs.Close();
                    }
                    completed++;
                    bwWorker.ReportProgress(0, completed);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString(), "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                sw?.Close();
                fsout?.Close();
                return;
            }
            finally
            {
                sr?.Close();
                fs?.Close();
                cmd?.Dispose();
                sql?.Close();
            }
            if (!checkNoFile.Checked)
            {
                sw.WriteLine();
                sw.WriteLine("----------------------------------");
                sw.WriteLine($"卡组总览（共{this.listDecks.Items.Count}个）");
                sw.WriteLine("----------------------------------");
            }
            int all = this.listDecks.Items.Count;
            Dictionary<string, int> list = new Dictionary<string, int>();
            while (overAllDeckType.Count > 0)
            {
                int most = 0;
                string mostKey = "";
                foreach (KeyValuePair<string, int> kvp in overAllDeckType)
                {
                    if (kvp.Value > most)
                    {
                        most = kvp.Value;
                        mostKey = kvp.Key;
                    }
                }
                string mostKeyModify = mostKey;
                if (mostKey.StartsWith("55张") || mostKey.StartsWith("56张") || mostKey.StartsWith("57张") ||
                    mostKey.StartsWith("58张") || mostKey.StartsWith("59张") || mostKey.StartsWith("60张"))
                {
                    mostKeyModify = mostKeyModify.Substring(3);
                }
                if (mostKeyModify.StartsWith("割草"))
                {
                    mostKeyModify = mostKeyModify.Substring(2);
                }
                if (mostKeyModify.Length == 0)
                {
                    mostKeyModify = "其他";
                }
                if (list.Keys.Contains(mostKeyModify))
                {
                    list[mostKeyModify] += overAllDeckType[mostKey];
                }
                else
                {
                    list.Add(mostKeyModify, overAllDeckType[mostKey]);
                }
                if (!checkNoFile.Checked)
                {
                    sw.WriteLine($"{mostKey} - {overAllDeckType[mostKey]}个 ({overAllDeckType[mostKey] * 100 / all} %)");
                }
                overAllDeckType.Remove(mostKey);
            }
            sw?.Close();
            fsout?.Close();
            string message = "处理结束";
            if (failed > 0)
            {
                message += "，失败{failed}个";
            }
            if (!checkNoFile.Checked)
            {
                MessageBox.Show(message);
            }
            bwWorker.ReportProgress(0, list);
        }

        private void bwWorker_ProgressChanged(object sender, ProgressChangedEventArgs e)
        {
            if (e.UserState is Dictionary<string, int>)
            {
                FormChart form = new FormChart(e.UserState as Dictionary<string,int>);
                form.Show();
            }
            else
            {
                txtStatus.Text = $"{(int)(e.UserState)} / {listDecks.Items.Count}";
            }
        }

        private void bwWorker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            btnStart.Enabled = true;
        }
    }
}
